
rm(list = ls()); gc()
setwd("/esarchive/scratch/nmilders/gitlab/git_clones/s2s-suite/")
recipe_file <- "recipes/recipe_1_nadia_scorecards.yml"

source("modules/Loading/Loading.R")
source("modules/Calibration/Calibration.R")
source("modules/Skill/Skill.R")
source("modules/Saving/Saving.R")

for (smonth in 1:12) {
## Define recipe needed to load calibrated data and skill metrics
  recipe <- read_yaml(recipe_file)
  recipe$Analysis$Time$sdate <- paste0(sprintf("%02d", smonth), '01')
## Load datasets
  data <- load_datasets(recipe_file)
## Compute skill metrics of raw data
  skill_metrics <- compute_skill_metrics(data$hcst, data$obs, recipe) 
  archive <- read_yaml(paste0(recipe$Run$code_dir, "conf/archive.yml"))$archive
  save_data(recipe, archive, data, skill_metrics = skill_metrics)  
}




