#'Function to define colors of table cells and text
#' 
#'@description Scorecards function to assign background color of table cells, 
#'  color of text in table and to bold the text.
#'

SC_table_colors <- function(table,
                            n.rows,
                            n.columns,
                            metrics,
                            metric.breaks,
                            n.start.months,
                            palette,
                            colorunder,
                            colorup,
                            metric.col,
                            metric.text.col){
  

  n.metrics <- length(metrics)
  
  ## temporary table in array format
  table_temp <- array(unlist(table[3:n.columns]), dim=c(n.rows,n.columns-2))


  ## Define cell and text colors to show in table
  for(met in 1:n.metrics){
    metric.int <- metric.breaks[[metrics[met]]]
    for(rr in 1:n.rows){
      for(stm in 1:n.start.months){
        for(pp in 1:(length(metric.int)-1)){
          if(is.nan(table_temp[rr,((met - 1) * n.start.months + stm)])){
            metric.col[rr,((met - 1) * n.start.months + stm)] <- "gray"
          } else {
            if(table_temp[rr,((met - 1) * n.start.months + stm)] >= metric.int[pp] && table_temp[rr,((met - 1) * n.start.months + stm)] <= metric.int[pp+1])
              metric.col[rr,((met - 1) * n.start.months + stm)] <- palette[pp]
            
            if(table_temp[rr,((met - 1) * n.start.months + stm)] < metric.int[1])
              metric.col[rr,((met - 1) * n.start.months + stm)] <- colorunder
            if(table_temp[rr,((met - 1) * n.start.months + stm)] >= metric.int[length(metric.int)])
              metric.col[rr,((met - 1) * n.start.months + stm)] <- colorsup
          }
          
          ## color text in white and bold if background is white or dark blue or dark red:
          if(is.nan(table_temp[rr,((met - 1) * n.start.months + stm)]) ||
             (!is.nan(table_temp[rr,((met - 1) * n.start.months + stm)]) && pp == 1 && table_temp[rr,((met - 1) * n.start.months + stm)] < metric.int[2]) ||
             (!is.nan(table_temp[rr,((met - 1) * n.start.months + stm)]) && pp == 2 && table_temp[rr,((met - 1) * n.start.months + stm)] < metric.int[3]) ||
             (!is.nan(table_temp[rr,((met - 1) * n.start.months + stm)]) && pp == (length(metric.int) - 1) && table_temp[rr,((met - 1) * n.start.months + stm)] >= metric.int[length(metric.int) - 1]) ||
             (!is.nan(table_temp[rr,((met - 1) * n.start.months + stm)]) && pp == (length(metric.int) - 2) && table_temp[rr,((met - 1) * n.start.months + stm)] >= metric.int[length(metric.int) - 2]))
          {
            metric.text.col[rr,((met - 1) * n.start.months + stm)] <- "white"
            #metric.text.bold[rr,((met - 1) * n.start.months + stm)] <- TRUE
          }
        } ## close loop on pp
      } ## close loop on stm
    } ## close loop on rr
  } ## close loop on met
  
  metric.col <- data.frame(metric.col)
  metric.text.col <- data.frame(metric.text.col)
  #metric.text.bold <- data.frame(metric.text.bold)
  
  return(list(metric.col = metric.col, 
              metric.text.col = metric.text.col))

} ## close function
