source("modules/Loading/Loading.R")
source("modules/Calibration/Calibration.R")
source("modules/Skill/Skill.R")
source("modules/Saving/Saving.R")
source("modules/Visualization/Visualization.R")

recipe_file <- "modules/Loading/testing_recipes/recipe_system7c3s-tas.yml"
recipe <- prepare_outputs(recipe_file)
# archive <- read_yaml(paste0(recipe$Run$code_dir, "conf/archive.yml"))$archive

# Load datasets
data <- load_datasets(recipe)
# Calibrate datasets
calibrated_data <- calibrate_datasets(recipe, data)
# Compute skill metrics
skill_metrics <- compute_skill_metrics(recipe, calibrated_data$hcst, data$obs)
# Compute percentiles and probability bins
probabilities <- compute_probabilities(recipe, calibrated_data$hcst)
# Export all data to netCDF
save_data(recipe, data, calibrated_data, skill_metrics, probabilities)
# Plot data
plot_data(recipe, data, calibrated_data, skill_metrics, probabilities,
	  significance = T)
